Attribute VB_Name = "Mod7K"

'**********************************************
'              Z X S P E C T A P E .
'**********************************************
'
'  *****  *   *
'     *    * *
'    *      *
'   *      * *
'  *****  *   *  Tools           -= XavSnap =-
'
'http://dskcenter.free.fr/zxtools.html
'**********************************************
'
' Spectrum Tape Converter.
' _______________________
' First Release: 12/2007.
' V1.3:          06/2008.
' V1.5:          12/01/2010.

Global Sommes() As Long
Global Id_Tab As Long
Global Eps_Tmp As Long
Global Wav_Header() As Byte
Global Tmp_Byte As Byte
Global Scroll_Offset As Double

Global PPS As Long

' Tampon global du fichier Wav charg.
Global Wav_Buffer() As Byte

' Copie du wav prcdent.
Global Undo_Buffer() As Byte

Global Setlevel As Long
Global Sel_S As Long
Global Sel_E As Long
Global bMethode As eDecMethode
Global Ignore_Level As Long
Global TmpLevel As Long
Global CursY As Long

Global ErrorsArray() As Boolean

Enum eDecMethode
surface = 0
trigger = 1
RMS = 2
End Enum

Enum eHard
spectrum = 0
raw = 1
TO7_70 = 2
CPC_1 = 3
ZXLR8 = 4
zx81 = 5
Inconnu = 6
BasiCodeB = 7
BasiCodeT = 8
End Enum

Enum eBlockType
RawDatas = 0
Header = 1
codes = 2
End Enum

' TZX declaration
Type eStand_DB
ID As Byte '&h10
Pause As Integer
Len_of_Block As Integer
End Type

Type ePause
ID As Byte '&h20
Pause As Integer
End Type

Type TZX_header
Signature As String * 7 ' Header "ZXTape!"
EoTF As Byte ' End of text file marker = &h1A
Maj_Version As Byte 'TZX major revision number
Min_Version As Byte 'TZX minor revision number
End Type

Type eArchive_info
ID As Byte '&h30
Len As Byte ' 25
Text As String * 25
End Type

' // Wav structure
Public wInfo As WaveHeaderInfo

Type WaveHeaderInfo
 channels As Integer
 freq As String
 bits As Integer
 kbps As Long
 wFilesize As String
 wPlaytime As String
End Type

Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function GetLongPathNameA Lib "kernel32.dll" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long

Public Function wHeadInfo(wavFileName As String) As Boolean
Dim wMins, wSecs As String
Dim riff As String * 4
Dim freq1x As String
Dim freq1 As Byte
Dim hFile As Integer

wInfo.wFilesize = FileLen(wavFileName)
hFile = FreeFile
Open wavFileName For Binary Access Read Lock Read As #hFile
    Get #1, 1, riff
    Get #1, 23, wInfo.channels
    Get #1, 35, wInfo.bits
    Get #1, 25, freq1
Close #hFile
freq1x = ConvertBase(Val(Str(freq1)), 10, 16)
If riff <> "RIFF" Then wHeadInfo = False: Exit Function
wHeadInfo = True

Select Case freq1x
Case 40
wInfo.freq = "8000"
Case 11
wInfo.freq = "11025"
Case 22
wInfo.freq = "22050"
Case 0
wInfo.freq = "32000"
Case 44
wInfo.freq = "44100"
Case 80
wInfo.freq = "48000"
Case Else
wInfo.freq = "1000"
End Select

wInfo.kbps = (CLng(wInfo.bits) * CLng(wInfo.channels) * CLng(Val(wInfo.freq)))
wInfo.wPlaytime = (((wInfo.wFilesize * 8) - 8000) / wInfo.kbps)
wMins = wInfo.wPlaytime \ 60
wSecs = wInfo.wPlaytime - (wMins * 60)
wInfo.wPlaytime = Format(wMins, "#0#") & ":" & Format(wSecs, "0#")

End Function
Function get_data(hFile As Integer) As Long
Dim Data_STR As String * 4
For off = 1 To 1500
Get #hFile, off, Data_STR
If Data_STR = "data" Then Exit For
Next
If off >= 1500 Then get_data = 45 Else get_data = off + 10
Get #hFile, off, Data_STR
If Data_STR = "RIFF" Then get_data = get_data + 46
End Function

Public Sub Get_WAV(File_Name As String)
Dim I_Count As Long
Dim Wav_Buffer16() As Integer
Dim Wav_Buffer16b() As Byte
Dim ln As Long
Dim hFile As Integer
Dim Tmp_Str As String
Dim Y1 As Byte
Dim Y2 As Byte
Dim ValY As Long
Dim Dta_OFF As Long

On Error Resume Next

Select Case wInfo.freq
Case "22050"
    If wInfo.bits = 8 Then
    ' Load The 8bits WAV files (sample 22050Hz).
        hFile = FreeFile
        Open File_Name For Binary Access Read As #hFile
         ln = LOF(hFile)
         Dta_OFF = get_data(hFile)
         ReDim Wav_Buffer(0 To ln - (Dta_OFF + 1)) As Byte
         Get #hFile, Dta_OFF, Wav_Buffer
        Close #hFile
    Else
    ' Load The 16bits WAV files (sample 22050Hz).
        hFile = FreeFile
        Open File_Name For Binary Access Read As #hFile
         ln = LOF(hFile)
         Dta_OFF = get_data(hFile)
         ReDim Wav_Buffer16(0 To (ln - (Dta_OFF + 1)) \ 2)
         Get #hFile, Dta_OFF, Wav_Buffer16
        Close #hFile
        ReDim Wav_Buffer((ln - 46) / 2)

        For I_Count = 0 To UBound(Wav_Buffer16) - 1
        Wav_Buffer(I_Count) = CByte(128 + ((Wav_Buffer16(I_Count) / 32767) * 128))
        Next
        Erase Wav_Buffer16
   
    End If
Case "44100"
    If wInfo.bits = 8 Then
    ' Load The 8bits WAV files (sample 44100Hz).
        hFile = FreeFile
        Open File_Name For Binary Access Read As #hFile
         ln = LOF(hFile)
         Dta_OFF = get_data(hFile)
         If ln < Dta_OFF Then Close #hFile: Exit Sub
         ReDim Wav_Buffer16b(0 To ln - (Dta_OFF + 1))
         Get #hFile, Dta_OFF, Wav_Buffer16b
        Close #hFile
        
        ReDim Wav_Buffer((ln - (Dta_OFF + 1)) / 2)
        For I_Count = 0 To UBound(Wav_Buffer) - 1
        Y1 = CByte(Wav_Buffer16b((I_Count * 2)))
        Y2 = CByte(Wav_Buffer16b((I_Count * 2) + 1))
        Wav_Buffer(I_Count) = CByte(IIf(Y1 > 128, IIf(Y1 >= Y2, Y1, Y2), IIf(Y1 <= Y2, Y1, Y2)))
        Next
        Erase Wav_Buffer16b

    Else
    ' Load The 16bits WAV files (sample 44100Hz).
    ' Signed (16bits)
        hFile = FreeFile
        Open File_Name For Binary Access Read As #hFile
         ln = LOF(hFile)
         Dta_OFF = get_data(hFile)
         ReDim Wav_Buffer16(0 To (ln - (Dta_OFF + 1)) \ 2)
         Get #hFile, Dta_OFF, Wav_Buffer16
        Close #hFile
        ReDim Wav_Buffer((ln - 46) / 4)

        For I_Count = 0 To UBound(Wav_Buffer16) - 1 Step 2
        Wav_Buffer(I_Count \ 2) = CByte(128 + Fix((Wav_Buffer16(I_Count) / 32768) * 128))
        Next
        Erase Wav_Buffer16
   
          
  

        Erase Wav_Buffer16
    End If
Case Else
    ' Load  WAV files (sample ???).
        hFile = FreeFile
        Open File_Name For Binary Access Read As #hFile
         ln = LOF(hFile)
         Dta_OFF = get_data(hFile)
         ReDim Wav_Buffer(0 To ln - (Dta_OFF + 1)) As Byte
         Get #hFile, Dta_OFF, Wav_Buffer
        Close #hFile

End Select

PPS = 22050

    Exit Sub
    
exit_sub:

    Close #hFile
End Sub


'This Function
Public Function ConvertBase(NumIn As String, BaseIn As Integer, _
    BaseOut As Integer) As String
    ' Converts a number from one base to another
    ' E.g. Binary = Base 2
    'Octal = Base 8
    'Decimal = Base 10
    'Hexadecimal = Base 16
    ' NumIn is the number which you wish to convert
        ' (A String including characters 0 - 9, A - Z)
    ' BaseIn is the base of NumIn (An integer value in
        ' Decimal between 1 & 36)
    ' BaseOut is the base of the number the function
        ' returns (An Integer value in Decimal between 1 & 36)
    ' Returns a string in the desired base containing the
        ' characters 0 - 9, A - Z)
    ' e.g. Debug.Print ConvertBase ("42", 8, 16) converts the octal n
    '     umber 42 into hexadecimal
    ' Returns the string "22"
    ' Returns the word "Error" if any of the input values
        ' are incorrect
    Dim i As Integer, CurrentCharacter As String, _
    CharacterValue As Integer, PlaceValue As Integer, _
    RunningTotal As Double, Remainder As Double, _
    BaseOutDouble As Double, NumInCaps As String
    ' Ensure input data is valid
    If NumIn = "" Or BaseIn < 2 Or BaseIn > 36 Or _
    BaseOut < 1 Or BaseOut > 36 Then
    ConvertBase = "Error"
    Exit Function
End If

' Ensure any letters in the input mumber are capitals
NumInCaps = UCase$(NumIn)
' Convert NumInCaps into Decimal
PlaceValue = Len(NumInCaps)

For i = 1 To Len(NumInCaps)
    PlaceValue = PlaceValue - 1
    CurrentCharacter = Mid$(NumInCaps, i, 1)
    CharacterValue = 0
    If Asc(CurrentCharacter) > 64 And _
    Asc(CurrentCharacter) < 91 Then _
    CharacterValue = Asc(CurrentCharacter) - 55


    If CharacterValue = 0 Then
        ' Ensure NumIn is correct
        If Asc(CurrentCharacter) < 48 Or _
        Asc(CurrentCharacter) > 57 Then
        ConvertBase = "Error"
        Exit Function
    Else
        CharacterValue = Val(CurrentCharacter)
    End If

End If

If CharacterValue < 0 Or CharacterValue > BaseIn - 1 Then
    ' Ensure NumIn is correct
    ConvertBase = "Error"
    Exit Function
End If

RunningTotal = RunningTotal + CharacterValue * _
(BaseIn ^ PlaceValue)
Next i

' Convert Decimal Number into the desired base using
    ' Repeated Division
Do
BaseOutDouble = CDbl(BaseOut)
Remainder = ModDouble(RunningTotal, BaseOutDouble)
RunningTotal = (RunningTotal - Remainder) / BaseOut

If Remainder >= 10 Then
    CurrentCharacter = Chr$(Remainder + 55)
Else
    CurrentCharacter = Right$(Str$(Remainder), _
    Len(Str$(Remainder)) - 1)
End If

ConvertBase = CurrentCharacter & ConvertBase
Loop While RunningTotal > 0

End Function

Public Function ModDouble(NumIn As Double, DivNum As Double) As Double
    ' Returns the Remainder when a number is divided by another
    ' (Works for double data-type)
    ModDouble = NumIn - (Int(NumIn / DivNum) * DivNum)
End Function

Public Function GetLongPathName(Shortpath As String) As String
   Dim s As String * 255
   Dim i As Long
   
   i = 255
  ' s = String(i, 0)
   GetLongPathNameA Shortpath, s, i
   
   GetLongPathName = Left$(s, InStr(s, Chr$(0)) - 1)
End Function

' Load a Text file in a TextBox.
Public Sub Load_Textb(Tbox As TextBox, File_Name As String)
Dim Lix As Integer, lsTransText As String
  Lix = FreeFile
  Open File_Name For Binary Access Read As #Lix

    ' Load the file
    If LOF(Lix) >= 32760 Then
    lsTransText = Space$(32750)
    Get #Lix, , lsTransText
    Tbox.Text = lsTransText & vbCrLf & "<CUT: File too big to be previewed in this box.>"
    Else
    lsTransText = Space$(LOF(Lix))
    Get #Lix, , lsTransText
    Tbox.Text = lsTransText & vbCrLf & "<EOF>"
    End If

  Close #Lix

End Sub

' Load a Text file in a TextBox.
Public Sub Load_Text(Tbox As TextBox, File_Name As String, Optional hard As eHard = raw)
Tbox.Text = ""
Dim Lix As Integer, lsTransText As String, Grap As Integer, Grap2 As Integer
Dim Tmpstr As String
Dim BuffTEXT() As Byte

If File_Name = "" Then Exit Sub

  Lix = FreeFile
  Open File_Name For Binary Access Read As #Lix
   
   If LOF(Lix) >= 32760 Then
   ReDim BuffTEXT(32750)
   Else
   ReDim BuffTEXT(LOF(Lix))
   End If
   Get #Lix, 1, BuffTEXT

  Grap = 1024
  Grap2 = UBound(BuffTEXT) - ((UBound(BuffTEXT) \ 1024) * 1024)
  For a = 0 To UBound(BuffTEXT) Step 1024
  
  If a >= ((UBound(BuffTEXT) \ 1024) * 1024) Then Grap = Grap2 - 1
   
  For B = 0 To Grap
  Select Case hard
  Case 4 Or 5
    lsTransText = lsTransText + ZXCharToASCII(BuffTEXT(a + B))

  Case Else
  If BuffTEXT(a + B) < &H20 Then BuffTEXT(a + B) = &H5F
  lsTransText = lsTransText + Chr(BuffTEXT(a + B))
  End Select
  Next
  Tmpstr = Tmpstr + lsTransText
  lsTransText = ""
  Next
  
    ' Load the file
    If LOF(Lix) >= 32760 Then
    lsTransText = Space$(32750)
    Tbox.Text = Tmpstr & vbCrLf & "<CUT: File too big to be previewed in this box.>"
    Else
    lsTransText = Space$(LOF(Lix))
    Tbox.Text = Tmpstr & vbCrLf & "<EOF>"
    End If

  Close #Lix

End Sub
Public Function ZXCharToASCII(ByVal cZX As Byte, Optional Func As Boolean = True, Optional ASM As Boolean = False) As String
' Convert ZX characters codes to PC Codes.
' Zx81 Memory to Pc Display.

' func =>
    If (cZX > 127 And cZX < 192) Then cZX = cZX And 63
     
 '   If (cZX And 64) = 64 Then ZXCharToASCII = "_": Exit Function

 
    Select Case cZX
    Case 0 ' // SPACE
        ZXCharToASCII = " "
    Case 11 To 13
        ' 11 = 34   "
        ' 12 = 35  /#
        ' 13 = 36  $
        ZXCharToASCII = Chr$(cZX + 23)
    Case 14
        ' 14 = :
        ZXCharToASCII = ":"
    Case 15
        ' 15 = ?
        ZXCharToASCII = "?"
    Case 16
        ' 16 = (
        ZXCharToASCII = "("
    Case 17
        ' 17 = )
        ZXCharToASCII = ")"
    Case 18
        ' 18 = >
        ZXCharToASCII = ">"
    Case 19
        ' 19 = <
        ZXCharToASCII = "<"
    Case 20
        ' 20 = =
        ZXCharToASCII = "="
    Case 21
        ' 21 = +
        ZXCharToASCII = "+"
    Case 22
        ' 22 = -
        ZXCharToASCII = "-"
    Case 23
        ' 23 = *
        ZXCharToASCII = "*"
    Case 24
        ' 24 = /
        ZXCharToASCII = "/"
    Case 25
        ' 25 = ;
        ZXCharToASCII = ";"
    Case 26
         ' 26 = ,
        ZXCharToASCII = ","
    Case 27
        ' 27 = .
        ZXCharToASCII = "."
    Case 28 To 37
        ZXCharToASCII = Chr$(cZX + 20)
    Case 38 To 63
        ZXCharToASCII = Chr$(cZX + 27)
    Case 82, 2
        If ASM Then ZXCharToASCII = "@" Else ZXCharToASCII = "_"
    Case 118
        If Not Func Then
        ZXCharToASCII = "_"
        Else
        If Not ASM Then ZXCharToASCII = "N/L" Else ZXCharToASCII = vbCrLf & vbTab
        End If
    Case 192 And Func
        ' 192 = "''"
        ZXCharToASCII = Chr$(34)
    Case 195 And Func
        ' 195 = "?"
        ZXCharToASCII = "?"
     Case 216 And Func
        ' 216 = "**"
        ZXCharToASCII = "**"
    Case 219 And Func
        ' 219 = "<="
        ZXCharToASCII = "<="
     Case 220 And Func
        ' 220 = ">="
        ZXCharToASCII = ">="
     Case 221 And Func
        ' 221 = "<>"
        ZXCharToASCII = "<>"
    Case Else
        ZXCharToASCII = "?"
    End Select
End Function

' Bytes arrays.
Function Copy_Memory(tArray1() As Byte, OffSET1 As Long, tArray2() As Byte, OffSET2 As Long, lenght As Long)
' Test COPYMEMORY values to avoid Kernel crash.
Dim Ddest As Long
Dim Dsource As Long
On Error GoTo End_Func
Ddest = UBound(tArray1)
Dsource = UBound(tArray2)
If lenght - 1 > (UBound(tArray2) - OffSET2) Then
GoTo End_Func
End If
If lenght - 1 > (UBound(tArray1) - OffSET1) Then
GoTo End_Func
End If

CopyMemory tArray1(OffSET1), tArray2(OffSET2), lenght
Exit Function
End_Func:
Debug.Print "error"
End Function


' Boolean arrays.
Function Copy_Memory1(tArray1() As Boolean, OffSET1 As Long, tArray2() As Boolean, OffSET2 As Long, lenght As Long)
' Test COPYMEMORY values to avoid Kernel crash.
Dim Ddest As Long
Dim Dsource As Long
On Error GoTo End_Func
Ddest = UBound(tArray1)
Dsource = UBound(tArray2)
If lenght > UBound(tArray2) - OffSET2 Then
GoTo End_Func
End If
If lenght > UBound(tArray1) - OffSET1 Then
GoTo End_Func
End If

CopyMemory tArray1(OffSET1), tArray2(OffSET2), lenght
Exit Function
End_Func:
Debug.Print "error"
End Function

' Get the path of a specified file name.( "c:\vb\tmp\file.txt" -> "c:\vb\tmp" )
Public Function Cut_Path_Name(Long_name_file As String) As String
On Error GoTo endfnc
Dim LastSlash, scan_path As Integer
Dim char_path As String * 1
If Long_name_file = "" Then Cut_Path_Name = "": Exit Function

Long_name_file = Trim(GetLongPathName(Long_name_file))

    scan_path = Len(Long_name_file)
    
Do While scan_path <> 1
    char_path = Mid(Long_name_file, scan_path, 1)
    If InStr(char_path, "\") <> 0 Then LastSlash = scan_path: Exit Do
    scan_path = scan_path - 1
Loop
If LastSlash <= 1 Then GoTo endfnc
Cut_Path_Name = Left(Long_name_file, LastSlash - 1)
Exit Function
endfnc:
Cut_Path_Name = Long_name_file
End Function
